Subject: Re: interprocess communication with netlinks

From: Randy Dunlap <[email-masked]>
Date: Mon, 11 May 2009 12:36:43 -0700

Daniel Lezcano wrote:
> Tianjin Zhang wrote:
>> i think the following  material can help you.
>>
>> 1. http://lwn.net/Articles/262385/  introduce the IPN,
>>
>> 2. http://www.linuxjournal.com/article/7356   introduce how to use
>> netlink
>> socket and why
>>   
> Thank you but I already saw these documents. I am used to play with the
> netlink for kernel <-> user communication, I am wondering if it is
> possible to have the applications to communicate, I mean user <-> user.
> 
> I saw a comment in the mailing list archive
> http://kerneltrap.org/mailarchive/linux-kernel/2007/12/7/493793/thread
> 
> "... with minor adjustments we have the facilities to
> meet your needs.  There is no need for yet-another-protocol to do what
> you're trying to do, we already have too much duplicated
> functionality."
> 
> 
> Were these "minor adjustements" done ?
> 
> Thanks
>  -- Daniel
> 
>> On Fri, May 8, 2009 at 12:00 AM, Daniel Lezcano
>> <[email-masked]>wrote:
>>
>>  
>>> Hi netdev gurus !
>>>
>>> I am trying to make several processes to communicate via the netlink
>>> protocol.
>>>
>>> I saw a discussion around the AF_IPN (inter process communication)
>>> protocol
>>> and it seems the same can be done with the AF_NETLINK protocol with
>>> minor
>>> modifications in the kernel. Were these modifications done ?
>>>
>>> I am trying to use multicast between several processes, for
>>> notification.
>>>
>>> What protocol should I use to create the socket ?
>>>
>>>   fd = socket(PF_NETLINK, SOCK_RAW,  ???);
>>>
>>> I was not able to find any suitable pointer to explain how to do
>>> that, so I
>>> blindly tried several combinations but I am afraid to interact with the
>>> other netlink protocols when using a multicast group, especially when
>>> there
>>> are other applications like avahi-daemon or "ip monitor all".
>>>
>>> Does anyone have a pointer to a documentation (not the redhat one,
>>> pls), or
>>> some clues ?

There's also a paper/doc here:
  http://people.redhat.com/nhorman/papers/netlink.pdf

-- 
~Randy
LPC 2009, Sept. 23-25, Portland, Oregon
http://linuxplumbersconf.org/2009/